/*
 * conf.h
 */
#ifndef CONF_H_
#define CONF_H_

/* paths to directories and files */
#define DEFAULT_CONFIG		"modbusd.conf"
#define DEFAULT_SOCKFILE	"modbusd.sock"

#ifndef PREFIX_DIR
 #define PREFIX_DIR		"/usr/local"
#endif

#define DAEMON_DIR		"modbusd"

#ifndef LOCALSTATE_DIR
 #define LOCALSTATE_DIR		PREFIX_DIR "/var/run"
#endif
#ifndef CONFIG_DIR
 #define CONFIG_DIR		PREFIX_DIR "/etc"
#endif

/* timeouts and session defaults */
#define MAX_SESSIONS		99
#define MIN_SESSIONS		1
#define MAX_KEEP_ALIVE		3600
#define MIN_KEEP_ALIVE		1

#define MODBUS_PORT		502
#define DEFAULT_KEEP_ALIVE	60
#define DEFAULT_MAX_SESSIONS	5

struct modbusd_options {
	int		port;
	unsigned int	input_image;
	unsigned int	output_image;
	unsigned int	max_sessions;
	unsigned int	keep_alive;
	char		sockfile[256];
	uid_t		user;
	gid_t		group;
	log_level_t	level;
	log_facility_t	facility;
	int		enable_syslog :1;

	unsigned int	inputs;
	unsigned int	inputs_offset;
	unsigned int	coils;
	unsigned int	coils_offset;
	unsigned int	input_regs;
	unsigned int	input_regs_offset;
	unsigned int	holding_regs;
	unsigned int	holding_regs_offset;
};

int parse_config(char *configfile, struct modbusd_options *opt);

#endif
